var KeyCode = Java.type('javafx.scene.input.KeyCode');
var Vector = Java.type('cz.upol.scripting.game.Vector');

var sceneWidth = 500;
var sceneHeight = 330;
var blockSize = 20;

function onInit()
{	
	game.createElement('wall', 0, 0, sceneWidth, blockSize);
	game.createElement('wall', 0, sceneHeight, sceneWidth, blockSize);
	game.createElement('wall', 0, 0, blockSize, sceneHeight);
	game.createElement('wall', sceneWidth - blockSize, 0, blockSize, sceneHeight);
	
	for (i = blockSize; i < sceneWidth - blockSize; i += blockSize) {
		for (j = 1; j < Math.random() * 20; j++) {
			game.createElement('wood', i, sceneHeight - j * blockSize, blockSize, blockSize);
		}
	}
	var duke = game.createElement('duke', 'duke', blockSize, blockSize, blockSize, blockSize);
	duke.speed = new Vector(10, 10 / (sceneWidth / blockSize));
}

function sgn(i)
{
	if (i < 0) return -1;
	if (i > 0) return 1;
	return 0;
}

function onKeyPressed(keyCode)
{
	var activeBombs = game.getByClass('bomb');
	if (activeBombs.length >= 3) return;
	var duke = game.getById('duke');
	if (keyCode == KeyCode.SPACE) game.createElement('bomb', duke.x, duke.y, blockSize, blockSize);
	if (keyCode == KeyCode.ENTER) {
		bomb = game.createElement('bomb', duke.x, duke.y, blockSize, blockSize);
		bomb.speed = new Vector(30 * sgn(duke.speed.x), duke.speed.y / 10);
	}
}

function onLoop()
{
	for each (var p in game.getByClass('bomb')) {
		p.speed = new Vector(p.speed.x, p.speed.y + 1);
	}
}

function onCollision(elt, obstacle, horizontal, vertical)
{
	if (elt.elementClass == 'duke') {
		if (obstacle.elementClass == 'wall') {
			if (horizontal) {
				elt.speed = new Vector(- elt.speed.x, elt.speed.y);
				return game.RETRY;
			}
			if (vertical) {
				game.completeGame("Congratulations !!!");
				return game.DONT_MOVE;
			}
		}
		if (obstacle.elementClass == 'wood') {
			game.completeGame("Game over");
			return game.DONT_MOVE;
		}
	}
	
	if (elt.elementClass == 'bomb') {
		if (obstacle.elementClass == 'wood') {
			obstacle.makeDisappear();
			elt.makeDisappear();
		}
		if (obstacle.elementClass == 'wall') {
			elt.makeDisappear();
		}	
	}
	return 0;
}
