from cz.upol.scripting.game import Vector
from javafx.scene.input import KeyCode

blockSize = 20;
sceneWidth = 500;
sceneHeight = 330;


def onInit():
	game.createElement('wall', 0, 0, sceneWidth, blockSize);
	game.createElement('wall', 0, sceneHeight, sceneWidth, blockSize);
	game.createElement('wall', 0, 0, blockSize, sceneHeight);
	game.createElement('wall', sceneWidth - blockSize, 0, blockSize, sceneHeight);
	
	brickSize = (sceneWidth - 2 * blockSize) / 8;
	for r in range(1, 7):
		for c in range(0, 8):
			game.createElement('wood', 2 + blockSize + c * brickSize, r * blockSize, brickSize, blockSize);
			
	game.createElement('paddle', 'paddle', (sceneWidth - brickSize) / 2, sceneHeight - blockSize * 1.5, 100, 20);
	
	ball = game.createElement('point', 'ball', sceneWidth / 2, sceneHeight / 2, blockSize, blockSize);
	ball.speed = Vector(10,  -10);

	
def onKeyPressed(keyCode):
	paddle = game.getById("paddle");
	if (keyCode == KeyCode.LEFT): paddle.speed = Vector(-10, 0);
	if (keyCode == KeyCode.RIGHT): paddle.speed = Vector(+10, 0);
	
def onCollision(elt, obstacle, horizontal, vertical):
	if ((elt.id == 'paddle') and (obstacle.elementClass == 'wall')): return game.DONT_MOVE_HORIZONTALLY;
	if (elt.id == 'ball'):
		if horizontal: elt.speed = Vector(- elt.speed.x, elt.speed.y);
		if vertical: elt.speed = Vector(elt.speed.x,  - elt.speed.y);
		if (obstacle.elementClass == 'wood'): obstacle.makeDisappear();
		if (vertical and (obstacle.elementClass == 'wall') and (elt.y > sceneHeight / 2)):
			game.completeGame("Game over");
			
	return 0;
	
def onLoop():
	if (game.getByClass("wood").size() == 0): game.completeGame("Congratulations !!!");
	return 0;
