package cz.upol.pja.lecture09;

import java.util.ArrayList;
import java.util.List;

import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

public class CallsJS {
	
	public static void main(String[] args) throws ScriptException, NoSuchMethodException {
		ScriptEngineManager sem = new ScriptEngineManager();
		ScriptEngine engine = sem.getEngineByName("JavaScript");
		
		System.out.println(engine.eval("1 + 1"));
		engine.put("a", 42);
		System.out.println(engine.eval("a + 1"));
		
		engine.eval("function sqr(x) { return x*x; }");
		System.out.println(engine.eval("sqr(10)"));
		
		Invocable inv = (Invocable) engine;
		System.out.println(inv.invokeFunction("sqr", 4));
		
		List<Integer> list = new ArrayList<>();
		list.add(1);
		list.add(2);
		
		engine.put("ll", list);
		engine.eval("ll.add(3)");
		System.out.println(list);
		
		engine.eval("var Color = Java.type('java.awt.Color')");
		
		engine.eval("blue = new Color(0.2, 0.3, 1.0)");
		System.out.println(engine.get("blue"));
		System.out.println(engine.eval("blue.getBlue()"));
		System.out.println(engine.eval("blue.green"));
		
		engine.eval("function Point(x, y) { this.x = x; this.y = y; this.asString = function() { return x + ', ' + y; } }");
		Object o = engine.eval("new Point(10, 20)");
		
		System.out.println(inv.invokeMethod(o, "asString"));
//		System.out.println(o.getClass());
	}

}
