package cz.upol.scripting;

import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.TextArea;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.HBox;
import javafx.stage.Modality;
import javafx.stage.Stage;

/**
 * Jednoduchy vstupni formular pro editaci textu
 */
public class CodeEditor {
	
	private final Stage primaryStage;
	private boolean ok;

	/**
	 * Vytvori formular, ktery bude navazany na rodicovskou primaryStage
	 */
	public CodeEditor(Stage primaryStage) {
		this.primaryStage = primaryStage;
	}
	
	/**
	 * Otevre okno editoru
	 * 
	 * @param text -- text, jenz se ma zobrazit
	 * @return vraci zadany text, nebo null, pokud uzivatel dal "Cancel"
	 */
	public String open(String text) {
		Stage stage = new Stage();
		TextArea codeEditor = new TextArea(text);
		
		Button okBtn = new Button("Ok");
		okBtn.setDefaultButton(true);
		okBtn.setOnAction(e -> { ok = true; stage.close(); });
		
		Button cancelBtn = new Button("Cancel");
		cancelBtn.setCancelButton(true);
		cancelBtn.setOnAction(e -> { ok = false; stage.close(); });
		
		HBox btnPane = new HBox(10);
		btnPane.getChildren().addAll(okBtn, cancelBtn);
		btnPane.setAlignment(Pos.BASELINE_CENTER);
		btnPane.setPadding(new Insets(10, 10, 10, 10));
		
		BorderPane root = new BorderPane();
		root.setCenter(codeEditor);
		root.setBottom(btnPane);
		
		Scene scene = new Scene(root, 400, 400);
		
		stage.initOwner(primaryStage);
		stage.initModality(Modality.WINDOW_MODAL);
		stage.setTitle("Code Editor");
		stage.setScene(scene);
		
		ok = true;
		stage.showAndWait();
		if (!ok) return null;
		return codeEditor.getText();
	}
}
