package cz.upol.scripting.game;

/**
 * Obdelnik, jenz ma strany rovnobezne s osami souradneho systemu. 
 * Nemenitelny objekt.
 */
public class Rect {
	
	private final double x;
	private final double y;
	private final double width;
	private final double height;
	
	public Rect(double x, double y, double width, double height) {
		super();
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
	}
	
	/**
	 * Vraci novy obdelnik, ktery ma souradnice posunute ve smeru <tt>direction</tt>
	 */
	public Rect move(Vector direction) {
		return new Rect(x + direction.getX(), y + direction.getY(), width, height);
	}
	
	public double getX() {
		return x;
	}
	
	public double getY() {
		return y;
	}
	
	public double getWidth() {
		return width;
	}
	
	public double getHeight() {
		return height;
	}
	
	/**
	 * Vraci true, pokud se dva obdelniky prekryvaji, jinak vraci false.
	 */
	public boolean isOverlapping(Rect r) {
		return ((this.x < r.x + r.width) && (this.x + this.width > r.x) && (this.y < r.y + r.height)
				&& (this.y + this.height > r.y));
	}
}
